with GNATCOM.IInterface;

with GNATCOM.Errors;

package body MSHTML.IHTMLTableCol3_Interface is

   procedure Initialize (This : in out IHTMLTableCol3_Type) is
   begin
      Set_IID (This, IID_IHTMLTableCol3);
   end Initialize;

   function Pointer (This : IHTMLTableCol3_Type)
     return Pointer_To_IHTMLTableCol3
   is
   begin
      return To_Pointer_To_IHTMLTableCol3 (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLTableCol3_Type;
                     Pointer : in     Pointer_To_IHTMLTableCol3)
   is
   begin
      Attach (This, GNATCOM.IInterface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_ch
     (This : IHTMLTableCol3_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_ch
         (Pointer (This),
          p));

      if Free then
               GNATCOM.IInterface.Free (p);
      
      end if;

   end Put_ch;

   function Get_ch
     (This : IHTMLTableCol3_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_ch
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_ch;

   procedure Put_chOff
     (This : IHTMLTableCol3_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_chOff
         (Pointer (This),
          p));

      if Free then
               GNATCOM.IInterface.Free (p);
      
      end if;

   end Put_chOff;

   function Get_chOff
     (This : IHTMLTableCol3_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_chOff
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_chOff;

end MSHTML.IHTMLTableCol3_Interface;

